#include	<stdio.h>
#include	<stdlib.h>
#include	<time.h>
#ifdef NEWS
#include    <unistd.h>
#endif
#include	<string.h>
#include	"countd.h"
#include	"disp_ctr.h"
#include    "getln.h"


int load_cfg(char *cfg_name, char *subj, struct tm *sime_tmsp,
			 int *s_year, int *s_mon, int *s_day, int *s_hour, int *s_min,
			 unsigned int *update,DEAD_COLOR dc[])
{
	FILE	*fp;
	char	*buf;
	int     len;
	int     retval;
	int     i;
	int     dc_idx;
	char    siki[LEN];
	char    tmpstr[LEN];

	int c_day;   /*    */
	int c_hour;  /*    */
	int c_min;   /*  ʬ  */
	int c_sec;   /*    */
	static char    *ident[11] = {  "BLACK",
						  "BLUE",
						  "RED",
						  "MAGENTA",
						  "GREEN",
						  "CYAN",
						  "YELLOW",
						  "WHITE",
						  "SUBJECT",
						  "DEADLINE",
						  "UPDATE" };


	if((fp = fopen(cfg_name, "r")) == NULL){
		rc_printf(2, "Can't open configuration file %s!\n", cfg_name);
		rc_printf(2, "Aborted!\n\n");
		r_color(-1);
		return -1;
	}


	strcpy(subj, "");
	*s_year  = -1;
	*s_mon = -1;
	*s_day   = -1;
	*s_hour  = -1;
	*s_min   = -1;
  	*update  = -1;
	for(i = 0; i < 8; i++){
		dc[i].color = -1;
		dc[i].sec = -1;
	}

	dc_idx = 0;
	buf = NULL;
	retval = 1;
	while(retval){
		retval = getln(&buf, &len, fp);
		if(retval == -1){
			rc_printf(2, "getln function error\n");
			fclose(fp);
			return -1;
		}

		if((*buf == '#') || (*buf == '\n')) continue;

		sscanf(buf, "%s", siki);
		
		for(i = 0; i < 8; i++){
			if(strcmp(siki, ident[i]) == 0){
				dc[dc_idx].color = i;
				sscanf(buf, "%s %d %d %d %d",
					   siki, &c_day, &c_hour, &c_min, &c_sec);
				dc[dc_idx].sec =
				  (((c_day * 24 + c_hour) * 60 + c_min) * 60 + c_sec);
				dc_idx++;
				break;
			}
		}
		
		if(strcmp(siki, "SUBJECT") == 0){
			sscanf(buf, "%s %s", siki, tmpstr);
			strcpy(subj, tmpstr);
		}
		else if(strcmp(siki, "DEADLINE") == 0){
			sscanf(buf, "%s %d %d %d %d %d", siki,
				   s_year, s_mon, s_day, s_hour, s_min);
		}
		else if(strcmp(siki, "UPDATE") == 0){
			sscanf(buf, "%s %d", siki, update);
		}
	}

	fclose(fp);
	
	if(strcmp(subj, "") == 0){ return -1; }
	
	if(*s_year  == -1){ return -1; }
	if(*s_mon   == -1){ return -1; }
	if(*s_day   == -1){ return -1; }
	if(*s_hour  == -1){ return -1; }
	if(*s_min   == -1){ return -1; }
  	if(*update  == -1){ return -1; }

	return 0;
}
